	/* dw - find duplicate words */
%{
#include <string.h>
#include <ctype.h>
char	last_word[1024];
long	last_line_number = 0L;
long	line_number = 1L;
void	make_lower();
%}
%%
[A-Za-z_][A-Za-z_0-9]*	{
	    make_lower();
	   /* (void)printf("\t[%s]\t[%s]\n",yytext,last_word); */
	    if (strcmp(yytext,last_word) == 0)
	    {
		if (last_line_number == line_number)
		    (void)printf("%ld: %s\n",
		        line_number,yytext);
		else
		    (void)printf("%ld-%ld: %s\n",
		        last_line_number,line_number,yytext);
	    }
	    (void)strcpy(last_word,yytext);
	    last_line_number = line_number;
	}

[^A-Za-z_ \t\n]+	{
			(void)strcpy(last_word,yytext); /* so intervening
			'words' do not trigger output of dups */
		}

\n		line_number++;

.		;	/* ignore everything else */
%%
void
make_lower()
{
    int n;
    for (n = 0; n < yyleng; ++n)
	if (isupper(yytext[n]))
	    yytext[n] = tolower(yytext[n]);
}
