# /u/sy/beebe/src/lex/dw/dw4.awk, Wed Apr  8 21:46:54 1992
# Edit by Nelson H. F. Beebe <beebe@csc-sun.math.utah.edu>
# ========================================================================
# Find doubled words in stdin or in a list of files on the command line.
# Usage:
#	gawk -f dw4.awk
# [09-Apr-1992]
# ========================================================================
BEGIN {FS = "[^A-Za-z0-9_]";}
{
    for (k = 1; k <= NF; ++k)
    {
#	printf("\t[%s]\t[%s]\n",$k,last_word);
	if (($k ~ /[A-Za-z_][A-Za-z_0-9]*/) && ($k == last_word))
	{
	    if (last_line != FNR)
	        printf("%d-%d: %s\n", last_line, FNR, $k);
	    else
	        printf("%d: %s\n", FNR, $k);
	}
	if (($k !~ /[ \t\n]+/) && ($k != ""))
	{
	    last_line = FNR;
	    last_word = $k;
	}
    }
}
