.TH DW 1L "08 April 1991"
.\"======================================================================
.SH "NAME"
dw \- find duplicate words
.\"======================================================================
.SH "SYNOPSIS"
.B dw
< infile >outfile
.PP
.B dw
filters its standard input, printing on standard output only those
words which appear twice in succession.  Each word is prefixed by
its line number(s).
.PP
A 
.I word
starts with a letter or underscore, and is followed by zero or more
letters, underscores, or digits.  Letter case is ignored.
.PP
This is a handy tool for finding a common typographical error in
documentation.
.PP
Its other purpose is to demonstrate a reasonably short
.BR lex (1)
program.
.\"======================================================================
.SH "SEE ALSO"
.BR awk (1),
.BR lex (1).
.\"======================================================================
.SH "AUTHOR"
Nelson H. F. Beebe, Ph.D.
.br
Center for Scientific Computing
.br
Department of Mathematics
.br
South Physics Building
.br
University of Utah
.br
Salt Lake City, UT 84112
.br
Tel: (801) 581-5254
.br
FAX: (801) 581-4148
.br
Email: <beebe@science.utah.edu>
.\"==============================[The End]==============================
